;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
;+
; @file_comments 
; Send back a vector or a matrix constituate of 0 and 1 in alternation
;
; you better use zero_one
;
; @obsolete
;
; @categories 
; Function, Matrix
;
; @param n1 {in}{required} number of elements in the first dimension
; @param n2 {in}{required} numbre of elements in the second dimension
;
; @returns resultat
; 
; @history Sebastien Masson (smasson\@lodyc.jussieu.fr)
;                       1/12/98
;
; @version $Id: zeroun.pro 157 2006-08-21 09:01:50Z navarro $
;
;-
;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
function zeroun, n1,n2
;
  compile_opt idl2, strictarrsubs
;
  case n_params() of
      0:return, zero_one()
      1:return, zero_one(n1)
      2:return, zero_one(n1, n2)
  endcase

end
